#ifndef _H_529E9AF0990E090F99057D381A4F9651_AprilTagDetection__H_
#define _H_529E9AF0990E090F99057D381A4F9651_AprilTagDetection__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "apriltag_msgs/msg/dds_opensplice/Point_.h"


namespace apriltag_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AprilTagDetection_
            {
                struct _corners__uniq_{};
                typedef ::apriltag_msgs::msg::dds_::Point_ _corners__slice;
                typedef ::apriltag_msgs::msg::dds_::Point_ _corners_[4];
                typedef DDS_DCPS_FArray_var< _corners_, _corners__slice, struct _corners__uniq_ > _corners__var;
                typedef _corners_ _corners__out;
                typedef DDS_DCPS_Array_forany< _corners_, _corners__slice, struct _corners__uniq_ > _corners__forany;
                static _corners__slice *_corners__alloc();
                static void _corners__free(_corners__slice *);
                static void _corners__copy(_corners__slice *to, const _corners__slice *from);
                static _corners__slice *_corners__dup(const _corners__slice *from);
                struct _homography__uniq_{};
                typedef ::DDS::Double _homography__slice;
                typedef ::DDS::Double _homography_[9];
                typedef DDS_DCPS_FArray_var< _homography_, _homography__slice, struct _homography__uniq_ > _homography__var;
                typedef _homography_ _homography__out;
                typedef DDS_DCPS_Array_forany< _homography_, _homography__slice, struct _homography__uniq_ > _homography__forany;
                static _homography__slice *_homography__alloc();
                static void _homography__free(_homography__slice *);
                static void _homography__copy(_homography__slice *to, const _homography__slice *from);
                static _homography__slice *_homography__dup(const _homography__slice *from);
                ::DDS::String_mgr family_;
                ::DDS::Long id_;
                ::DDS::Long hamming_;
                ::DDS::Float goodness_;
                ::DDS::Float decision_margin_;
                ::apriltag_msgs::msg::dds_::Point_ centre_;
                _corners_ corners_;
                _homography_ homography_;
            };

            typedef DDS_DCPSStruct_var<AprilTagDetection_> AprilTagDetection__var;
            typedef DDS_DCPSStruct_out < AprilTagDetection_> AprilTagDetection__out;

        }

    }

}

#endif /* _H_529E9AF0990E090F99057D381A4F9651_AprilTagDetection__H_ */
